/* Taken from the tetris plugin,
   (c) Clemens Kirchgatterer <clemens@thf.ath.cx> 2002
   
*/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef _DISPLAY_H_
#define _DISPLAY_H_

#include <vdr/osd.h>


enum Color {
	BGR, RED, GRN, BLU, YEL, MAG, CYN, WHT, BLK, TRS
};

void initXBitmap(cBitmap &b);
void initOBitmap(cBitmap &b);
void initEmptyBitmap(cBitmap &b);
int  DisplayOpen(int x, int y, int w, int h);
int  DisplayClose(void);
int  DisplayWidth(void);
int  DisplayHeight(void);
int  DisplayFontHeight(void);
int  DisplayCharWidth(char c);
int  DisplayStringWidth(const char *s);
void DisplayDrawBlock(int x, int y, Color col);
void DisplayDrawRect(int x1, int y1, int x2, int y2, Color col);
void DisplayDrawBitmap(int x, int y, const cBitmap &bitmap);
void DisplayClearBlock(int x, int y);
void DisplayPrintText(int x, int y, const char *txt);
void DisplayMessage(const char *txt, Color col);
void DisplayClearMessage();
void DisplayUpdate(void);

#endif
