/***************************************************************************
 *                                                                         *
 *   This program is free software{ you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation{ either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/
#include <stdlib.h>
#include <time.h> 
#include <string.h> 

#include <vdr/interface.h>

#include <vdr/i18n.h>
#include "kaesekaestchen.h"
#include "display.h"

//The TicTacToe/Ksekstchen code is taken from an old Java applet of mine,
//written as a first programming exercise.
//It is written in German - actually in C++, but the naming
//and the comments are German and I won't translate them.
//However, everything in German is _not_ related to vdr,
//it's only the game itself.

int a; //size of one of the nine squares
int b; //width of one line
int w,h; //width, height
#define LINECOLOR BLU

//these were 'final' java variables
#define spieler false
#define computer true
#define spiele -1
#define compute 1

//public
Kaesekaestchen::Kaesekaestchen() :
  xBitmap(80,80,2, true),
  oBitmap(80,80,2, true),
  emptyBitmap(80,80,2, true)
 // spieler(false),
 // computer(true),
 // spiele(-1),
 // compute(1)
{
   a=80;
   b=4;
   w=h=3*a+2*b;

   anzGewonneneSpieleComputer=0;
   anzGewonneneSpieleSpieler=0;
   anzSpieleGesamt=0;
   anzMussHin=0;
   schonInitiiert=false;   
   dirtyScreen=false;
   messageDisplaying=false;
   resetting=false;
   //these should be configurable
   beginner=false;  //spieler per default
   stufe=0;
   
}

Kaesekaestchen::~Kaesekaestchen()
{
}

void Kaesekaestchen::Start(int x, int y) {
   srand(time(NULL));
   beginner=false;
   DisplayOpen(x, y, w, h);
   
   //fill bitmaps. EmptyBitmap remains empty
   initXBitmap(xBitmap);
   initOBitmap(oBitmap);
   initEmptyBitmap(emptyBitmap);
   //draw lines
   DisplayDrawRect(a,0,a+b-1,h,LINECOLOR);
   DisplayDrawRect(2*a+b,0,2*a+2*b-1,h,LINECOLOR);
   DisplayDrawRect(0,a,w,a+b-1,LINECOLOR);
   DisplayDrawRect(0,2*a+b,w,2*a+2*b-1,LINECOLOR);
   DisplayUpdate();
   
   startKK();
}
void Kaesekaestchen::Stop() {
   DisplayClose();
}
void Kaesekaestchen::set(int xfield, int yfield) {
   if (resetting) 
      resetting=false;
   if (messageDisplaying) {
      DisplayClearMessage();
      DisplayUpdate();
      messageDisplaying=false;
   }
   if (legal(xfield, yfield, spieler)) {
      setze(xfield, yfield, spieler);
      ziehe();
   }
}
void Kaesekaestchen::increaseDifficulty() {
   if (resetting) 
      resetting=false;
   if (stufe>0) stufe--;
   const char*msg;
   switch (stufe) {
   case 0:
      msg=tr("Invincible");
      break;
   case 1:
      msg=tr("Human");
      break;
   case 2:
      msg=tr("Ridiculous");
      break;
   }
   DisplayClearMessage();
   DisplayMessage(msg,BLU);
   DisplayUpdate();
   messageDisplaying=true;
}
void Kaesekaestchen::decreaseDifficulty() {
   if (resetting) 
      resetting=false;
   if (stufe<2) stufe++;
   const char*msg;
   switch (stufe) {
   case 0:
      msg=tr("Invincible");
      break;
   case 1:
      msg=tr("Human");
      break;
   case 2:
      msg=tr("Ridiculous");
      break;
   }
   DisplayClearMessage();
   DisplayMessage(msg,BLU);
   DisplayUpdate();
   messageDisplaying=true;
}
void Kaesekaestchen::toggleBeginner() {
   if (resetting) 
      resetting=false;
   beginner=!beginner;
   DisplayClearMessage();
   if(beginner==computer)
      DisplayMessage(tr("Computer begins"),GRN);
   else
      DisplayMessage(tr("You begin"),GRN);
   DisplayUpdate();
   messageDisplaying=true;
}
void Kaesekaestchen::resetGame() {
   DisplayClearMessage();
   DisplayMessage(tr("Reset game? (OK)"), RED);
   DisplayUpdate();
   messageDisplaying=true;
   resetting=true;
}
void Kaesekaestchen::pressedOk() {
   if (resetting) {
      startKK();
      resetting=false;
   }
}









//private
void Kaesekaestchen::startKK() {  
   reinit();
   if (weristdran==computer && spielBeendet==false)
      ziehe();
}

void Kaesekaestchen::reinit() {
   for (int i=0;i<3;i++){ //Brett wird auf Anfangszustand,also=0,gesetzt
      for(int j=0;j<3;j++) {
         brett[i][j]=0;
      }
   }
   if (dirtyScreen)
      cleanScreen();
   spielBeendet=false;
   weristdran=beginner;
   erzeugeAlt();
}   
   


void Kaesekaestchen::endSequenz() {
spielBeendet=true;
anzSpieleGesamt++;
if (sieger==compute) {
   anzGewonneneSpieleComputer++;
   DisplayMessage(tr("You lost!"), RED);
} else if (sieger==spiele) {
   anzGewonneneSpieleSpieler++;
   DisplayMessage(tr("You won!"), GRN);
} else 
   DisplayMessage(tr("That's a tie."), BLU);
DisplayUpdate();
messageDisplaying=true;
startKK();
}




bool Kaesekaestchen::ende (const int br[3][3]) {
/*Diese Methode wird mit einem Brett gefttert, das vom Sinn nur das reale sein kann. Gibt es 3er, wird true zurckgegeben und sieger auf den richtigen Wert gestzt.
Die Methode eignet sich nicht zur Errechnung eines Zuges; dafr bietet check2er() alle Mglichkeiten.
*/
z=0;

for(int i=0;i<3;i++) {      //Spalten werden geprft
 z=0;
   for (int j=0;j<3;j++) {
      z=br[i][j]+z;
      }
   if (z==3) {
   sieger=compute;
   return true;
   }
   if(z==-3) {
   sieger=spiele;
   return true;}
 }

for(int i=0;i<3;i++) {      //Reihen berprfen
 z=0;
   for(int j=0;j<3;j++) {
      z=br[j][i]+z;
      }
   if (z==3) {
   sieger=compute;
   return true;
   }
   if(z==-3) {
   sieger=spiele;
   return true;}
 }
 z=0;
z=br[0][0]+br[1][1]+br[2][2];   //erste Diagonale
   if (z==3) {
   sieger=compute;
   return true;
   }
   if(z==-3) {
   sieger=spiele;
   return true;}

 z=0;
z=br[2][0]+br[1][1]+br[0][2];      //zweite Diagonale
   if (z==3) {
   sieger=compute;
   return true;
   }
   if(z==-3) {
   sieger=spiele;
   return true;}
sieger=0;
return false;
}       //Ende Methode ende







void Kaesekaestchen::setze(int x,int y,bool wer) {    //Setzt Stein von wer aufs Brett
if(wer)
   brett[x][y]=1;
else
   brett[x][y]=-1;

   //DRAWING
bool oval= (wer==computer); //perhaps make this configurable
switch (y) {
case 0: switch (x) {
      case 0:
         DisplayDrawBitmap(0,0, oval ? oBitmap : xBitmap); 
         break;
      case 1:
         DisplayDrawBitmap(a+b,0, oval ? oBitmap : xBitmap); 
         break;
      case 2:
         DisplayDrawBitmap(2*a+2*b,0, oval ? oBitmap : xBitmap); 
         break;
      }
   break;
case 1: switch (x) {
      case 0:
         DisplayDrawBitmap(0,a+b, oval ? oBitmap : xBitmap); 
         break;
      case 1:
         DisplayDrawBitmap(a+b,a+b, oval ? oBitmap : xBitmap); 
         break;
      case 2:
         DisplayDrawBitmap(2*a+2*b,a+b, oval ? oBitmap : xBitmap); 
         break;
      }
   break;
case 2: switch (x) {
      case 0:
         DisplayDrawBitmap(0,2*a+2*b, oval ? oBitmap : xBitmap); 
         break;
      case 1:
         DisplayDrawBitmap(a+b,2*a+2*b, oval ? oBitmap : xBitmap); 
         break;
      case 2:
         DisplayDrawBitmap(2*a+2*b,2*a+2*b, oval ? oBitmap : xBitmap); 
         break;
      }
   break;
 }//Ende switch

DisplayUpdate();
erzeugeAlt();
dirtyScreen=true; //painted bitmaps something on OSD
weristdran=computer;
} 

void Kaesekaestchen::cleanScreen() {
   for (int i=0;i<=2;i++) {
      for (int j=0;j<=2;j++) { //gives the same combinations as in the above method
         DisplayDrawBitmap(i*a+i*b,j*a+j*b, emptyBitmap);
      }
   }
   dirtyScreen=false;
   DisplayUpdate();
}
  
   
bool Kaesekaestchen::legal(int x,int y,bool wer) {   //ist der Zug korrekt und mglich
if (brett[x][y]==0 && wer==weristdran)
   return true;
else {   
   return false;
   }
}


//Here is the intelligence
void Kaesekaestchen::ziehe() {
if (ende(brett)) {
   endSequenz();
   return;
   }
int zug;
if (alt.isNull())
   zug=5;
else {
   if(alt.length()==1)
      zug=5;
   else {
      if (beginner)
         zug=((9-alt.length())+2)/2;
      else  zug=((9-alt.length())+1)/2;
   }
}
switch (zug) {
case 1: if (stufe==2)
      setzeBeliebig();
   else { //stufe 0+1
      if (beginner) {
         setze1zu4(); //in dieser Methode noch Unterscheidung zwischen Stufe 0 und 1
         }
      else { 
         if (brett[1][1]==-1){
            setzeInBeliebigeEcke();
            varZug1Ziehe=true;
            }
         else  {    //Mitte ist frei
            if (stufe==0) {
               setze(1,1,computer);
               varZug1Ziehe=false;
               }
            else    //stufe 1
               setze1zu4(); //setzt nur zur Hfte in die Mitte
            }
         } //zweites else, beginner==spieler
      } //erstes else, stufe 0+1
   break;
case 2:
   if (stufe==2)
      setzeBeliebig();
   else { //stufe 0+1
   if (beginner) {
         if (varZug1BeginnerZiehe) {
            if (brett[1][1]==-1)
               setzeProblem1Umgekehrt(); //hier wieder Unterscheidung 0+1 in Methode
            else {
               if (stufe==0)
                  setze(1,1,computer);
               else    //stufe==1
                  setzeBeliebig();
               }
            }
         else {
            if (brett[0][0]==-1 || brett[2][0]==-1 || brett[0][2]==-1 || brett[2][2]==-1)
               setze2er();
            else  setzeInBeliebigeEcke();
            }
      }
   else {
      if (varZug1Ziehe) {
         if (check2er(brett,spieler)) //Der menschliche Spieler von Stufe 1 ist nicht blind!
            setze(mussHin,computer);
         else  setzeBeliebig();
         }
      else {
         if (check2er(brett,computer)==false && check2er(brett,spieler)) {
            check2er(brett,spieler);      //um mussHin wieder sicher richtig zu setzen
            setze(mussHin,computer);
            }
         else {   if (check2er(brett,computer)) {
               setze(mussHin,computer);
               break;
               }
            if (setzeProblem1()==false)
               setze2er();
            }
         }
      }
   }//oberstes else, stufe 0+1   
   break;
case 3:

case 4:if (check2er(brett,computer)==false && check2er(brett,spieler)) {
         check2er(brett,spieler);         //um mussHin wieder sicher richtig zu setzen
         if (stufe==2 && gib0oder1()==0)
            setzeBeliebig();   //Computer in Stufe 2 IST blind!
         else
            setze(mussHin,computer);
         }
    else {
         if (check2er(brett,computer))
            if (stufe==2 && gib0oder1()==0)
               setzeBeliebig();
            else
               setze(mussHin,computer);
         else {
            if (setze2er()==false)
               setzeBeliebig();
            }
         }
   break;
case 5:    
   if (beginner)
      setzeBeliebig();
   ende(brett);
   endSequenz();
   //weristdran=computer;
   return;

}//Ende Switch

weristdran=spieler;
if (ende(brett))
   endSequenz();
}



//Helper methods for ziehe():

bool Kaesekaestchen::check2er(const int br[3][3],bool wer) {//wer:spieler oder comp

/*Diese Methode bekommt ein beliebiges 3,3 Feld vorgesetzt und ent-
scheidet,ob darin ein 2er vorkommt(return-Wert:ja/nein).
Gibt es mehrere 2er,wird die Variable anzMussHin auf diese 
Anzahl gesetzt.
Auerdem wird,sofern es 2er gibt,ein Punkt mussHin festgelegt, der
diesen 2er zum 3er macht. Es gibt fr diese Methode also zwei 
Anwendungen:
1. Sie wird nacheinander mit allen mglichen Kombinationen gefttert,
um zu entscheiden, wo der nchste Stein hin soll. Dabei ist zu beachten,
dass bei jedem Aufruf mussHin und anzMussHin gelscht werden.Diese
Ergebnisse sollten also zum Vergleich und zur Anwendung in lokalen
Variablen der aufrufenden Methode gespeichert werden.
Achtung: wer=computer
2. berprfung,ob der Gegner einen 2er hat, dabei mit dem 
aktuellen Brett fttern und wer=spieler.
Hat er einen, muss auf MussHin gesetzt werden, hat er zwei, hat der Com
verloren - natrlich ein Programmierfehler ;-)
   Diese Methode kann also mit dem realen und noch nicht realen Brettern ausgefhrt werden
*/
mussHin.setNull(true);
anzMussHin=0;

int werzahl;
z=0;
bool ergebnis=false;

if(wer)      //es muss klar sein,fr wen es ein 2er sein soll
   werzahl=2;//fr computer
else   werzahl=-2;//fr spieler
for(int i=0;i<3;i++) {      //Spalten werden geprft
 z=0;
   for (int j=0;j<3;j++) {
      z+=br[i][j];
      }
   if (z==werzahl) {
      if(mussHin.isNull()){
      mussHin.reset();
      ergebnis=true;
      anzMussHin++;
      mussHin.x=i;
      for (int j=0;j<3;j++) {
         if(br[i][j]==0)
            mussHin.y=j;
         }
      } else {
      anzMussHin++;
      }
    }
 }

for(int i=0;i<3;i++) {      //Reihen berprfen
 z=0;
   for(int j=0;j<3;j++) {
      z=br[j][i]+z;
      }
   if(z==werzahl) {
      if(mussHin.isNull()) {
      mussHin.reset();
      ergebnis=true;
      anzMussHin++;
      mussHin.y=i;
      for (int j=0;j<3;j++) {
         if(br[j][i]==0)
            mussHin.x=j;
         }
      } else {
      anzMussHin++;
      }
   }
 }
z=br[0][0]+br[1][1]+br[2][2];   //erste Diagonale
   if(z==werzahl) {
      if(mussHin.isNull()) {
      mussHin.reset();
      ergebnis=true;
      anzMussHin++;
      if(br[0][0]==0){
         mussHin.y=0;
         mussHin.x=0;}
      if(br[1][1]==0){
         mussHin.y=1;
         mussHin.x=1;}
      if(br[2][2]==0){
         mussHin.x=2;
         mussHin.y=2;}
      } else {
      anzMussHin++;
      }
   }


z=br[2][0]+br[1][1]+br[0][2];      //zweite Diagonale
   if(z==werzahl) {
      if(mussHin.isNull()) {
      mussHin.reset();
      ergebnis=true;
      anzMussHin++;
      if(br[2][0]==0){
         mussHin.y=0;
         mussHin.x=2;}
      if(br[1][1]==0){
         mussHin.y=1;
         mussHin.x=1;}
      if(br[0][2]==0){
         mussHin.x=0;
         mussHin.y=2;}
      } else {
      anzMussHin++;
      }
   }
return ergebnis;

}      //Ende Methode check2er


bool Kaesekaestchen::setze2er() {
anzMHSetze2er=0;
for (int i=0;i<alt.length();i++) {
   int nbr[3][3];
   memcpy(nbr,brett,3*3*sizeof(int));
   nbr[alt[i].x][alt[i].y]=1;
   if (check2er(nbr,computer) && (anzMussHin>anzMHSetze2er) ) {
      anzMHSetze2er=anzMussHin;
      MHSetze2er=alt[i];
   }
}
if (anzMHSetze2er==0)
   return false;
setze(MHSetze2er,computer);
return true;
}      


/*int Kaesekaestchen::kopiereBrett() {
int br[3][3];
br[0][0]=brett[0][0];
br[0][1]=brett[0][1];
br[0][2]=brett[0][2];
br[1][0]=brett[1][0];
br[1][1]=brett[1][1];
br[1][2]=brett[1][2];
br[2][0]=brett[2][0];
br[2][1]=brett[2][1];
br[2][2]=brett[2][2];
return br;
}*/


bool Kaesekaestchen::setzeProblem1() {   
int werzahl=-2;
int reiheOben=brett[0][0]+brett[1][0]+brett[2][0];
int reiheUnten=brett[0][2]+brett[1][2]+brett[2][2];
if ((reiheOben+brett[2][1]+brett[2][2])==werzahl) {
   setze(2,0,computer);
   return true;
   }
if ((reiheUnten+brett[2][1]+brett[2][0])==werzahl) {
   setze(2,2,computer);
   return true;
   }
if ((reiheUnten+brett[0][1]+brett[0][0])==werzahl) {
   setze(0,2,computer);
   return true;
   }
if ((reiheOben+brett[0][1]+brett[0][2])==werzahl) {
   setze(0,0,computer);
   return true;
   }
return false;
}

static const Point arrayForSetzeInBeliebigeEcke[] =
     { Point(0,0),Point(2,0),Point(0,2),Point(2,2),
       Point(0,0),Point(0,2),Point(0,0),Point(2,0) };
      
void Kaesekaestchen::setzeInBeliebigeEcke() {
Point po;
do {
   po=arrayForSetzeInBeliebigeEcke[nextInt(8)];
 } while (brett[po.x][po.y]!=0); //solange, bis freie Ecke herauskommt
setze(po,computer);
}



void Kaesekaestchen::setzeBeliebig() {
Point po=alt[nextInt(alt.length())];
setze(po,computer);
}



static const int zuf0[]={1,2,1,1,1,1,2,2,1,2,1,2,1,1,1,1,1,1,2,2,2,1,2,1,1,1,1}; //ca. 1:4
static const int zuf1[]={1,2,1,2,1,2,1,2,1,2,1,2}; //50:50

void Kaesekaestchen::setze1zu4() {
//int[] zuf;
//if (stufe==0)
int i;
if (stufe==0)
   i=zuf0[nextInt(27)]; //length of array
else 
   i=zuf1[nextInt(12)];
if (i==1){
   setzeInBeliebigeEcke();
   varZug1BeginnerZiehe=true;
   }
else  {
   setze(1,1,computer);
   varZug1BeginnerZiehe=false;
   }
}



void Kaesekaestchen::setzeProblem1Umgekehrt() {
if (stufe==1)
   if (gib0oder1()==0) {
      setzeBeliebig();  //setzt bei stufe 1 mit 50:50 beliebig, sonst richtig
      return;
      }
if (brett[0][0]==1)
   setze(2,1,computer);
if (brett[2][0]==1)
   setze(1,2,computer);
if (brett[0][2]==1)
   setze(1,0,computer);
if (brett[2][2]==1)
   setze(0,1,computer);
}




void Kaesekaestchen::erzeugeAlt() {
alt.setNull();
for(int i=0;i<3;i++) {
   for (int j=0;j<3;j++) {
      if (brett[i][j]==0)
         alt.add(Point(i,j));
   }
}
}

int Kaesekaestchen::nextInt(int n) {
int i= 1+(int) ( ((float)n)*rand()/(RAND_MAX+1.0));
if (i==n)
   i--;
if (i<0)
   i=1;
return i;
}

static const int zuf[]={0,1,0,1,1,1,0,0,1,0,1,1,0,0,0,1,1,1,1,1,0,0,1,0,1,1};

int Kaesekaestchen::gib0oder1() {   //die Null ist im Feld weniger oft vorhanden!
return zuf[nextInt(26)];
}

